const uri = /[a-z][a-z0-9+-.]*:((\/\/(([a-z0-9-\._~!$&'\(\)\/\*\+,;=:]|%[a-f0-9]{2})*@)?((([0-9]|[1-9][0-9]|1[0-9]{2}|2[0-4][0-9]|25[0-5])\.){3}[0-9]|[1-9][0-9]|1[0-9]{2}|2[0-4][0-9]|25[0-5])|([a-z0-9-\._~!$&'\(\)\/\*\+,;=]|%[a-f0-9]{2})+(:[0-9]+)?(\/[a-z0-9-\._~!$&'\(\)\/\*\+,;=:@]*|%[a-f0-9]{2})*)|(\/(([a-z0-9-\._~!$&'\(\)\/\*\+,;=:@]+|%[a-f0-9]{2})(\/[a-z0-9-\._~!$&'\(\)\/\*\+,;=:@]*|%[a-f0-9]{2})*)?)|(([a-z0-9-\._~!$&'\(\)\/\*\+,;=:@]+|%[a-f0-9]{2})(\/[a-z0-9-\._~!$&'\(\)\/\*\+,;=:@]*|%[a-f0-9]{2})*))+(\?([a-z0-9-\._~!$&'\(\)\/\*\+,;=:@/?]|%[a-f0-9]{2})*)?(#([a-z0-9-\._~!$&'\(\)\/\*\+,;=:@/?]|%[a-f0-9]{2})*)?/i;
var ul;

function main()
{
	var expression = ".//text()";
	var elements = document.evaluate(expression, document.body, null, XPathResult.UNORDERED_NODE_SNAPSHOT_TYPE, null);
	if (elements == null) return;
	ul = document.createElement("ul");
	for (var i = 0; i < elements.snapshotLength; i++) collectLink(elements.snapshotItem(i));
	var firstChild = document.body.firstChild;
	document.body.insertBefore(ul, firstChild);
}

function collectLink(element)
{
//	if (element.nodeValue == null) return;
	var matches = element.nodeValue.match(uri);
	if (matches == null) return;
	var text = matches[0];
	var index = element.nodeValue.indexOf(text);
	if (index == 0)
	{
		if (element.nodeValue.length > text.length) collectLink(element.splitText(text.length));
		var li = document.createElement("li");
		li.appendChild(document.createTextNode(element.nodeValue));
		ul.appendChild(li); // COLLECT LINK
	}
	else collectLink(element.splitText(index));
}

main();
