const CHARACTERS =
{
	// RESERVED CHARACTERS
	"$": /%24/g,	"&": /%26/g,	"+": /%2B/gi,	",": /%2C/gi,	"/": /%2F/gi,
	":": /%3A/gi,	";": /%3B/gi,	"=": /%3D/gi,	"?": /%3F/gi,	"@": /%40/g,
	// EXCLUDED CHARACTERS
	" ": /%20/g,	"\"": /%22/g,	"#": /%23/g,	"%": /%25/g,	"<": /%3C/gi,
	">": /%3E/gi,	"[": /%5B/gi,	"\\": /%5C/gi,	"]": /%5D/gi,	"^": /%5E/gi,
	"`": /%60/g,	"{": /%7B/gi,	"|": /%7C/gi,	"}": /%7D/gi,	"~": /%7E/gi
};

function main()
{
	var expression = "./html/head/meta[translate(@http-equiv,'REFRESH','refresh')='refresh' and contains(@content,'url=')]";
	var elements = document.evaluate(expression, document, null, XPathResult.UNORDERED_NODE_SNAPSHOT_TYPE, null);
	if (elements != null) window.addEventListener("load", function(){window.stop();}, false); // DOES NOT WORK WHEN COMING BACK TO A PAGE

	expression = ".//a[contains(@href,'http://')]";
	elements = document.evaluate(expression, document.body, null, XPathResult.UNORDERED_NODE_SNAPSHOT_TYPE, null);
	if (elements == null) return;
	for (var i = 0; i < elements.snapshotLength; i++) skipRedirect(elements.snapshotItem(i));
}

function skipRedirect(element)
{
	var href = element.getAttribute("href");
	var index = href.lastIndexOf("http://");
	if (index <= 0) return;
	href = href.substring(index);
	var href = "" + href.match(/[^?#&]+/);
	for (var ch in CHARACTERS) href = href.replace(CHARACTERS[ch], ch);
	element.setAttribute("href", href); // SKIP REDIRECT
}

main();
